/*
 * RCS info: $Source: /export/work/usr/CVS_DB/FP-Fixer/src/lib/fpfsim/fpfsim2_int.h,v $
 *           $Revision: 1.10 $
 *           $Date: 2010/03/15 08:21:17 $
 *           $Author: haru $
 *           $Log: fpfsim2_int.h,v $
 *           Revision 1.10  2010/03/15 08:21:17  haru
 *           *** empty log message ***
 *
 *           Revision 1.9  2010/01/14 09:14:10  haru
 *           *** empty log message ***
 *
 *           Revision 1.8  2009/12/17 09:15:31  haru
 *           *** empty log message ***
 *
 *           Revision 1.7  2009/09/14 00:22:35  haru
 *
 *           (1)float area 0 -> 0 bit sim
 *           (2)even rnd -> log long bug
 *
 *           Revision 1.6  2009/09/07 00:41:26  haru
 *
 *           Chg. rnd-mode e, r
 *
 *           Revision 1.5  2009/07/31 09:24:40  haru
 *
 *           Add. dump trace info
 *
 *           Revision 1.4  2009/06/25 11:19:00  haru
 *
 *           Grouping simulation
 *
 *           Revision 1.3  2009/03/31 01:05:01  haru
 *
 *           Chg. mul calc
 *
 *           Revision 1.2  2009/03/19 01:54:04  haru
 *
 *           090319
 *
 *           Revision 1.1  2009/02/23 05:13:50  haru
 *
 *           new version
 *
 *           Revision 1.2  2008/11/28 07:25:48  haru
 *           first cvs modules.
 *
 * Copyright (c) 2009 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 
 * ԡ
 * ե̾fpfsim2_int.c
 *   ӥåȲϡʥߥ졼ѡ
 *==========================================================================*/

#ifndef _FPFFIXED_INT_HPP_
#define _FPFFIXED_INT_HPP_


/*************************************************************************
 * CONSTANT VALUE
 *************************************************************************/
// BASE ӥåȥ
#define __BASE_BIT_SIZE32 32
#define __BASE_BIT_SIZE64 64

// error flag
#define FIXED_OK        0
#define FIXED_ERROR     -1

// Хե⡼
enum fpf_OvMode {
    FPF_OV_WRAP = 0,    // 0ʤڼΤơʥåץ饦ɡ
    FPF_OV_SAT,         // 1ʤ˰
    fpf_OvModeSize
};

// ݤ⡼
enum fpf_RndMode {
    FPF_RND_WRAP = 0,   // 0ʤڼΤ
    FPF_RND_ZERO,       // 1ʤ01
    FPF_RND_CONV,       // 2ʤݤ
    FPF_RND_CEILING,    // 3ʤceiling
    FPF_RND_FLOOR,      // 4ʤfloor
    fpf_RndModeSize
};

// ե饰
enum fpf_PFlag {
    FPF_P_FLAG_WAIT = 0,// 0ʤ̤
    FPF_P_FLAG_FIXING,  // 1ʤ꾮
    FPF_P_FLAG_FIXED    // 2ʤ꾮Ѥ
};

enum _fpf_ValType{
    FPFSIM_TYPE_NON,
    FPFSIM_VOID,
    FPFSIM_BOOL,
    FPFSIM_CHAR,
    FPFSIM_SHORT,
    FPFSIM_INT,
    FPFSIM_LONG,
    FPFSIM_LONGLONG,
    FPFSIM_FLOAT,
    FPFSIM_DOUBLE,
    FPFSIM_LONGDOUBLE,
    FPFSIM_STRUCT,
};

enum _fpf_Signed{
    FPFSIM_SIGNED_NON,
    FPFSIM_SIGNED,
    FPFSIM_UNSIGNED,
};



/*************************************************************************
 * ǡ
 *************************************************************************/
// ѿǡ
typedef struct __fpf_unit {
    int     var_no;     // ѿֹ
    char    *var_name;  // ѿ̾
    char    *func_name; // ؿ̾ ʥХѿ'$'
    char    *file_name; // ե̾ 
    int     line_no;    // եֹ

    int     p_flag;     // ե饰0ʤ̤
                        //             1ʤ꾮
                        //             2ʤ꾮Ѥ
    int     i_flag;     // 32,64ӥåȥե饰
    short   i_width;    // ӥå
    short   f_width;    // ӥå

    short   ec_flag;    // ؿ 1: 2:
    short   ec_bitw;    // ؿӥå

    short   org_fwidth; // ǽξӥå
    short   wk_fwidth;  // Ⱦӥå

    int     ope_no;     // 黻ֹͥ
    int     state;      //   0:normal 1:overflow
    int     job_type;   // 
    int     type;       // ѿ
    int     iSgndF;     // ե饰
    int     grp_no;     // 롼ֹ
    int     fz_flg;     // ե饰
    int     fx_flg;     // ǥ쥯ƥ֤Ǹ경ե饰
//    int     array_size; // 
    int     over_msg;   // Сեåե饰

    // 硢Ǿͥǡ
    int         i_set_flag;     // ͥåȥե饰
    double      i_max_value;    // κ
    double      i_min_value;    // κǾ
    int         m_set_flag;     // ͥåȥե饰
    double      m_max_value;    // κ ʤξ硢κǾ͡
    double      m_min_value;    // κǾ ʤξ硢κǾ͡
    double      last_value;     // Ǹ

    short   ok_fwidth;          // Ⱦӥå
    short   f2fx_fwidth;        // 
} _FPF_UNIT;

// ѿꥹ
typedef struct _fpf_varlist
{
    _FPF_UNIT *pUnit;
    struct _fpf_varlist *pNext;
    struct _fpf_varlist *pSort;
    struct _fpf_varlist *pGrp;
    struct _fpf_varlist *pBitGrp;
} _FPF_VARLIST;

// ѿ¸
typedef struct _fpf_bwdata
{
    int         i_flag;     // 32 or 64 ӥåȻѥե饰 0:32ӥå 1:64ӥå
    double      fval;       // ưꥢ
    int         ival;       // 꾮ꥢ32ӥåȡ
    long long   ilval;      // 꾮ꥢ64ӥåȡ

    short       i_width;    // ӥå
    short       f_width;    // ӥå
    int         ope_no;     // 黻No
    int         type;       // Υ

    int         varNo;      // ѿֹ
    char        ov_mode;
    char        rnd_mode;
    int         init_flag;  // ǡե饰

    int         array_no;   // ֹ
    int         array_size; // 
    void        *shp;       // ѿΰ 
                            // äƤκǽΥɥ쥹
   __fpf_unit   *u;         // ơ֥륢ɥ쥹
    struct _fpf_saveData *pNext;
} _FPF_BWDATA;

// 黻ꥹ
typedef struct _fpf_exp_list
{
    int             exp_code;
    int             upd_var_no;
    char            *upd_var_name;
    _FPF_VARLIST    *upd_var_list;
    int             left_var_no;
    char            *left_var_name;
    _FPF_VARLIST    *left_var_list;
    int             right_var_no;
    char            *right_var_name;
    _FPF_VARLIST    *right_var_list;
    struct _fpf_exp_list *pNext;
} _FPF_EXP_LIST;


// ӥåȸơ֥
typedef struct _fpf_sim_bit
{
    int     iBitWidth;
    int     iVarNum;
    _FPF_VARLIST    *pVarList;  // bitGrp³
                                // Ȥ
} _FPF_SIM_BIT;


//
// Хؿǥե
//

extern int _FPFSIM_SttSetAddr( void *pSrc, void *pDest );
extern int _FPFSIM_SttSetAddr( void *pSrc, void *pDest, int iSize, int iNo );
extern void *_FPFSIM_SttGetAddr( void *pSrc );
extern int _FPFSIM_SttPush();
extern void _FPFSIM_SttPop();
extern void __fpfsim_calcResultVar( int iVarNo, int rnd_mode );

#endif // !_FPFFIXED_INT_HPP_

